unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, ExtCtrls;

type
  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    Panel1: TPanel;
    OpenDialog1: TOpenDialog;
    Button1: TButton;
    ListBox1: TListBox;
    Splitter1: TSplitter;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
    DatabaseIO, Info;

{$R *.dfm}

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TForm1.FormCreate(Sender: TObject);
begin
    //  f[^x[XANZXNX쐬
    DB := TDatabaseJet.Create();
end;

//-----------------------------------------------------------------------------
//  tH[j
procedure TForm1.FormDestroy(Sender: TObject);
begin
    //  f[^x[XANZXNXj
    DB.Free();
end;

//-----------------------------------------------------------------------------
//  mdbt@C̑I
procedure TForm1.Button1Click(Sender: TObject);
var
    LPath: String;
    LErr: String;
    i: Integer;
begin
    Button1.Enabled := False;

    //  t@CI_CAO\
    if (OpenDialog1.Execute()) then
    begin
        //  łɃf[^x[XJĂ
        DB.Close();

        //  t@CIꂽ
        LPath := OpenDialog1.FileName;

        //  mdbt@CƉ肵ĊJĂ݂(pX[h͂ȂƂ)
        if (DB.Open('', '', LPath, LErr)) then
        begin
            ListBox1.Clear();

            //  ObhNA
            for i := 0 to StringGrid1.ColCount - 1 do
            begin
                StringGrid1.Cols[i].Clear();
            end;
            StringGrid1.ColCount := 1;
            StringGrid1.RowCount := 2;

            //  e[üꗗ\
            DB.GetTableNames(ListBox1.Items);                

            //  ڂI
            if (ListBox1.Items.Count > 0) then
            begin
                ListBox1.ItemIndex := 0;
                ListBox1Click(ListBox1);
            end;
        end

        //  JȂ烁bZ[W\
        else
        begin
            AppMessageBox(LErr, MB_OK or MB_ICONINFORMATION);
        end;            
    end;

    Button1.Enabled := True;
end;

//-----------------------------------------------------------------------------
//  e[uI
procedure TForm1.ListBox1Click(Sender: TObject);
var
    LList: TListBox;
    LGrid: TStringGrid;
    i: Integer;
    LBuf: TStringList;
    LTable: String;
    LText: String;
    LSQL: String;
    LSet: OleVariant;
    LErr: String;
    LIndex: Integer;
    LWidth: Integer;
begin
    LList := TListBox(Sender);

    //  I`FbN
    if (LList.ItemIndex = -1) then Exit;

    //  e[u
    LTable := LList.Items.Strings[LList.ItemIndex];

    //  bN
    LGrid := StringGrid1;
    LBuf := TStringList.Create();

    LList.Enabled := False;
    LGrid.Enabled := False;
    Button1.Enabled := False;
    Screen.Cursor := crHourGlass;

    //  ObhNA
    for i := 0 to LGrid.ColCount - 1 do
    begin
        LGrid.Cols[i].Clear();
    end;
    LGrid.ColCount := 1;
    LGrid.RowCount := 2;

    //  e[ũtB[h擾
    DB.GetTableFields(LTable, LBuf);

    //  Obhɓ]L
    if (LBuf.Count > 0) then
    begin
        LGrid.ColCount := LBuf.Count;
        for i := 0 to LBuf.Count - 1 do
        begin
            LText := LBuf.Strings[i];
            LGrid.ColWidths[i] := LGrid.Canvas.TextWidth(LText + ' ');
            LGrid.Cells[i, 0] := LText;
        end;

        //  Sf[^擾
        LSQL := Format('SELECT * FROM [%s]', [LTable]);
        if (DB.OpenQuery(LSQL, LSet, LErr)) then
        begin
            LIndex := 1;
            while (not DB.IsXOF(LSet)) do
            begin
                LGrid.RowCount := LIndex + 1;

                for i := 0 to LGrid.ColCount - 1 do
                begin
                    LText := NVL(DB.FieldValue(LSet, i), '');
                    LWidth := LGrid.Canvas.TextWidth(LText + ' ');
                    if (LWidth > LGrid.ColWidths[i]) then
                    begin
                        LGrid.ColWidths[i] := LWidth;
                    end;
                    LGrid.Cells[i, LIndex] := LText;
                end;

                DB.MoveNext(LSet);
                Inc(LIndex);
            end;
        end
        else
        begin
            AppMessageBox(LErr, MB_OK or MB_ICONINFORMATION);
        end;
    end;

    //  bN
    Screen.Cursor := crDefault;
    Button1.Enabled := True;
    LList.Enabled := True;
    LGrid.Enabled := True;
    LBuf.Free();
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
    OpenInfoForm();
end;

procedure TForm1.Button3Click(Sender: TObject);
var
    LErr: String;
begin
    if (not TDatabaseJet(DB).CompactDatabase(LErr)) then
    begin
        AppMessageBox(LErr, MB_OK or MB_ICONINFORMATION);
    end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
    LErr: String;
begin
    DB.BeginTrans();
    if (not DB.Execute(Edit1.Text, LErr)) then
    begin
        AppMessageBox(LErr, MB_OK or MB_ICONINFORMATION);
    end;
    DB.RollbackTrans();
end;

end.
